package com.unipi.talepis.softeng7;

import java.sql.*;

public class SQLiteDB {
    static void createTableAndDataV1(){
        try {
            Connection connection =
                    DriverManager.getConnection("jdbc:sqlite:./sqliteDB.db");
            Statement statement = connection.createStatement();
            String createSQL = "CREATE TABLE IF NOT EXISTS STUDENT1" +
                    "(AM TEXT NOT NULL," +
                    "NAME TEXT," +
                    "GRADE INTEGER," +
                    "PRIMARY KEY(AM))";
            statement.execute(createSQL);
            String insertSQL = "INSERT OR IGNORE INTO STUDENT1 VALUES('P19123','PETROS',8)";
            statement.execute(insertSQL);
            statement.close();
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
    //Using Transactions
    static void createTableAndDataV2(){
        try {
            Connection connection =
                    DriverManager.getConnection("jdbc:sqlite:./sqliteDB.db");
            connection.setAutoCommit(false);
            Statement statement = connection.createStatement();
            String createSQL = "CREATE TABLE IF NOT EXISTS STUDENT2" +
                    "(AM TEXT NOT NULL," +
                    "NAME TEXT," +
                    "GRADE INTEGER," +
                    "PRIMARY KEY(AM))";
            statement.execute(createSQL);
            String insertSQL = "INSERT OR IGNORE INTO STUDENT2 VALUES('P19123','PETROS',8)";
            statement.execute(insertSQL);
            connection.commit();
            statement.close();
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
    static void createTableAndDataV3(){
        try {
            Connection connection =
                    DriverManager.getConnection("jdbc:sqlite:./sqliteDB.db");
            connection.setAutoCommit(false);
            Statement statement = connection.createStatement();
            String createSQL = "CREATE TABLE IF NOT EXISTS STUDENT3" +
                    "(AM TEXT NOT NULL," +
                    "NAME TEXT," +
                    "GRADE INTEGER," +
                    "PRIMARY KEY(AM))";
            statement.execute(createSQL);
            String insertSQL = "INSERT OR IGNORE INTO STUDENT3 VALUES(?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(insertSQL);
            preparedStatement.setString(1,"P19321");
            preparedStatement.setString(2,"Maria");
            preparedStatement.setInt(3,9);
            preparedStatement.executeUpdate();
            connection.commit();
            statement.close();
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
    static void createTableAndDataV4(){
        try {
            Connection connection =
                    DriverManager.getConnection("jdbc:sqlite:./sqliteDB.db");
            connection.setAutoCommit(false);
            Statement statement = connection.createStatement();
            String createSQL = "CREATE TABLE IF NOT EXISTS STUDENT4" +
                    "(AM TEXT NOT NULL," +
                    "NAME TEXT," +
                    "GRADE INTEGER," +
                    "PRIMARY KEY(AM))";
            statement.execute(createSQL);
            String insertSQL = "INSERT OR IGNORE INTO STUDENT4 VALUES(?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(insertSQL);
            preparedStatement.setString(1,"P19321");
            preparedStatement.setString(2,"Maria");
            preparedStatement.setInt(3,9);
            preparedStatement.addBatch();
            preparedStatement.setString(1,"P19322");
            preparedStatement.setString(2,"Marios");
            preparedStatement.setInt(3,9);
            preparedStatement.addBatch();
            preparedStatement.executeBatch();
            connection.commit();
            statement.close();
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
    static void createTableAndDataV5(){
        try {
            Connection connection =
                    DriverManager.getConnection("jdbc:sqlite::memory:");
            connection.setAutoCommit(false);
            Statement statement = connection.createStatement();
            String createSQL = "CREATE TABLE IF NOT EXISTS STUDENT3" +
                    "(AM TEXT NOT NULL," +
                    "NAME TEXT," +
                    "GRADE INTEGER," +
                    "PRIMARY KEY(AM))";
            statement.execute(createSQL);
            String insertSQL = "INSERT OR IGNORE INTO STUDENT3 VALUES(?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(insertSQL);
            preparedStatement.setString(1,"P19321");
            preparedStatement.setString(2,"Maria");
            preparedStatement.setInt(3,9);
            preparedStatement.executeUpdate();
            connection.commit();
            statement.close();
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
    static void createTableAndDataV6(){
        try {
            Connection connection =
                    DriverManager.getConnection("jdbc:sqlite::memory:");
            connection.setAutoCommit(false);
            Statement statement = connection.createStatement();
            String createSQL = "CREATE TABLE IF NOT EXISTS STUDENT3" +
                    "(AM TEXT NOT NULL," +
                    "NAME TEXT," +
                    "GRADE INTEGER," +
                    "PRIMARY KEY(AM))";
            statement.execute(createSQL);
            String insertSQL = "INSERT OR IGNORE INTO STUDENT3 VALUES(?,?,?)";
            PreparedStatement preparedStatement = connection.prepareStatement(insertSQL);
            preparedStatement.setString(1,"P19321");
            preparedStatement.setString(2,"Maria");
            preparedStatement.setInt(3,9);
            preparedStatement.executeUpdate();
            connection.commit();
            connection.createStatement().executeUpdate("backup to ./sqliteSavedFromMemory.db");
            // "restore from"
            statement.close();
            connection.close();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }
}
